<?php
/*
Plugin Name: Entrecard Admanager
Plugin URI: http://www.mrparkle.com/entrecardadmanager
Description: Accept Entrecard credits and easily manage 125x125 ads within your WordPress Dashboard.
Author: Mr Parkle
Author URI: http://www.mrparkle.com
Version: 2.1
(based on the original wp125 plugin by Matt Harzewski)
(makes use of the PHPInclusion plugin */

define("MANAGEMENT_PERMISSION", "edit_themes");

//Stylesheet
function ECadmanager_stylesheet() {
echo '<link rel="stylesheet" href="'.ECadmanager_get_plugin_dir('url').'/ECadmanager.css" type="text/css" media="screen" />'."\n";
}
add_action('wp_print_scripts', 'ECadmanager_stylesheet');


//Installer
function ECadmanager_install () {
require_once(dirname(__FILE__).'/installer.php');
}
register_activation_hook(__FILE__,'ECadmanager_install');


//Create Widget
function ECadmanager_create_ad_widget() {
register_sidebar_widget(__('ECadmanager'), 'ECadmanager_write_ads_widget');
}
function ECadmanager_write_ads_widget($args) {
extract($args);
echo $before_widget;
if (get_option("ECadmanager_widget_title")!='') {
echo $before_title; echo get_option("ECadmanager_widget_title"); echo $after_title;
}
ECadmanager_write_ads();
echo $after_widget;
}

//Add the Admin Menus
if (is_admin()) {
function ECadmanager_add_admin_menu() {
add_menu_page("125x125 Ads", "Entrecard Ads", MANAGEMENT_PERMISSION, __FILE__, "ECadmanager_write_managemenu");
add_submenu_page(__FILE__, "Manage Entrecard Ads", "Manage", MANAGEMENT_PERMISSION, __FILE__, "ECadmanager_write_managemenu");
add_submenu_page(__FILE__, "Add/Edit Entrecard Ads", "Add/Edit", MANAGEMENT_PERMISSION, 'ECadmanager_addedit', "ECadmanager_write_addeditmenu");
add_submenu_page(__FILE__, "Entrecard Admanager Settings", "Settings", MANAGEMENT_PERMISSION, 'ECadmanager_settings', "ECadmanager_write_settingsmenu");
}

//Include menus
require_once(dirname(__FILE__).'/adminmenus.php');
}



//Check Ad Date, and deactivate if the time is up
function ECadmanager_CheckAdDate($thedate, $theid) {
global $wpdb;
$adtable_name = $wpdb->prefix . "ecadmanager_ads";
if ($thedate!='00/00/0000') {
$today = strtotime(date('m').'/'.date('d').'/'.date('Y'));
$thedate = strtotime($thedate);
if ($today > $thedate) {
$updatedb = "UPDATE $adtable_name SET status='0' WHERE id='$theid'";
$results = $wpdb->query($updatedb);
sendExpirationEmail($theid);
} else { return; }
} else { return; }
}



//Write the Ads
function ECadmanager_write_ads() {
global $wpdb;
$setting_ad_orientation = get_option("ECadmanager_ad_orientation");
$setting_num_slots = get_option("ECadmanager_num_slots");
$setting_ad_order = get_option("ECadmanager_ad_order");
$setting_buyad_url = "./?page_id=".get_option("ECadmanager_pid_sell");
$setting_defaultad = get_option("ECadmanager_defaultad");
$adtable_name = $wpdb->prefix . "ecadmanager_ads";
$theorder = 'RAND() LIMIT '.$setting_num_slots;
$theads = $wpdb->get_results("SELECT * FROM $adtable_name WHERE status = '1' ORDER BY $theorder", ARRAY_A);
if ($theads) {
if ($setting_ad_orientation=='1c') {
echo '<div id="ECadmanageradwrap_1c">';
$arraycount = 0;
foreach ($theads as $thead){
ECadmanager_CheckAdDate($thead['end_date'], $thead['id']);
$theslot = $thead['slot'];
$adguidearray[$theslot] = $thead;
$arraycount++;
}
//Random listing of the ads
srand((float)microtime() * 1000000);
shuffle($adguidearray);
$adguidearray_shufflefix = $adguidearray[0]; $adguidearray[0]=''; $adguidearray[]=$adguidearray_shufflefix;

for ($curslot=1; $curslot <= $setting_num_slots; $curslot++) {
if (isset($adguidearray[$curslot])) {
$linkurl = $adguidearray[$curslot]['target'];
echo '<div class="ECadmanagerad"><a href="'.$linkurl.'" rel="nofollow"><img src="'.$adguidearray[$curslot]['image_url'].'" alt="'.$adguidearray[$curslot]['name'].'" /></a></div>';
} else { //Default ad but limit viewable slots
	if ($limitslots==0){
	echo '<div class="ECadmanagerad"><a href="'.$setting_buyad_url."&slot=".$curslot.'" rel="nofollow"><img src="'.$setting_defaultad.'" alt="" /></a></div>';$limitslots=1; }}
}

echo '</div>';
}
if ($setting_ad_orientation=='2c') {
echo '<div id="ECadmanageradwrap_2c">';
$arraycount = 0;
foreach ($theads as $thead){
ECadmanager_CheckAdDate($thead['end_date'], $thead['id']);
$theslot = $thead['slot'];
$adguidearray[$theslot] = $thead;
$arraycount++;
}

srand((float)microtime() * 1000000);
shuffle($adguidearray);
$adguidearray_shufflefix = $adguidearray[0]; $adguidearray[0]=''; $adguidearray[]=$adguidearray_shufflefix;

for ($curslot=1; $curslot <= $setting_num_slots; $curslot++) {
if (isset($adguidearray[$curslot])) {
$linkurl = $adguidearray[$curslot]['target'];
echo '<div class="ECadmanagerad"><a href="'.$linkurl.'" rel="nofollow"><img src="'.$adguidearray[$curslot]['image_url'].'" alt="'.$adguidearray[$curslot]['name'].'" /></a></div>';
} else { //Default ad but limit viewable slots
	if ($limitslots==0){
	echo '<div class="ECadmanagerad"><a href="'.$setting_buyad_url."&slot=".$curslot.'" rel="nofollow"><img src="'.$setting_defaultad.'" alt="" /></a></div>';$limitslots=1; }}
}
echo '</div>';
}
} else
//No ads listed
if ($setting_ad_orientation=='1c') {
echo '<div id="ECadmanageradwrap_1c">';
echo '<div class="ECadmanagerad"><a href="'.$setting_buyad_url.'" rel="nofollow"><img src="'.$setting_defaultad.'" alt="" /></a></div></div>';}
if ($setting_ad_orientation=='2c') {
echo '<div id="ECadmanageradwrap_2c">';
echo '<div class="ECadmanagerad"><a href="'.$setting_buyad_url.'" rel="nofollow"><img src="'.$setting_defaultad.'" alt="" /></a></div></div>';}
}


function ECadmanager_single_ad($theslot) {
global $wpdb;
$adtable_name = $wpdb->prefix . "ecadmanager_ads";
$thead = $wpdb->get_row("SELECT * FROM $adtable_name WHERE slot = '$theslot' AND status = '1' ORDER BY id DESC", OBJECT);
if ($thead) {
ECadmanager_CheckAdDate($thead->end_date, $thead->id);
$linkurl = $thead->target;
echo '<a href="'.$linkurl.'" rel="nofollow"><img src="'.$thead->image_url.'" alt="'.$thead->name.'" /></a>';
} else { echo '<a href="'.get_option("ECadmanager_buyad_url").'" rel="nofollow"><img src="'.get_option("ECadmanager_defaultad").'" alt="Your Ad Here" /></a>'; }
}


//Return path to plugin directory (url/path)
function ECadmanager_get_plugin_dir($type) {
if ( !defined('WP_CONTENT_URL') )
define( 'WP_CONTENT_URL', get_option('siteurl') . '/wp-content');
if ( !defined('WP_CONTENT_DIR') )
define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
if ($type=='path') { return WP_CONTENT_DIR.'/plugins/'.plugin_basename(dirname(__FILE__)); }
else { return WP_CONTENT_URL.'/plugins/'.plugin_basename(dirname(__FILE__)); }
}


//Send email alert to admin when an ad expires
function sendExpirationEmail($theid) {
global $wpdb;
$adtable_name = $wpdb->prefix . "ecadmanager_ads";
$thead = $wpdb->get_row("SELECT * FROM $adtable_name WHERE id='$theid'", OBJECT);
if (get_option('ECadmanager_emailalertexp')!='') {
$theblog = get_option('blogname');
$from = get_option('admin_email');
$message = "One of the advertisements on $theblog has expired.\n\nAD NAME: ".$thead->name."\nAD URL: ".$thead->target."\nSTART DATE: ".$thead->start_date."\nEND DATE: ".$thead->end_date."\n\nFor more information, and to manage your ads, please log in to your WordPress administration.\n\n\n*** Powered by WordPress and ECadmanager ***";
$headers = "From: $from\r\nReply-To: $from";
$mail_sent = @mail(get_option('ECadmanager_emailalertexp'), "An ad on your blog has expired", $message, $headers);
}
return;
}


function phpinclusion_tag($mode,$files) {
	if ( get_the_author_login()=='admin' ) {
	switch ($mode) {
		case "include":
    		include($files);
    		break;
	case "include_once":
	case "includeonce":
    		include_once($files);
    		break;
	case "require":
    		require($files);
    		break;
	case "require_once":
	case "requireonce":
    		require_once($files);
    		break;
	default:
	}
	}
}

function phpinclusion_check($the_content) {

	if ((strpos($the_content, "[require:")!==FALSE)||(strpos($the_content, "[include:")!==FALSE)|| (strpos($the_content, "[require_once:")!==FALSE)||(strpos($the_content, "[include_once:")!==FALSE) || (strpos($the_content, "[requireonce:")!==FALSE)||(strpos($the_content, "[includeonce:")!==FALSE)) { 
		preg_match_all('/\[(?<name>\w+):([^\])]+)/', $the_content, $matches, PREG_SET_ORDER); 
		foreach($matches as $match) { 
			$the_content = preg_replace("/\[(?<name>\w+):([^\])]+)\]/", phpinclusion_tag($match[1], $match[2]), $the_content,1);

		}
		
	}
    return $the_content;
}

function phpinclusion_install(){
  if(get_option('phpinclusion_posts' == '') || !get_option('phpinclusion_posts')){
    add_option('phpinclusion_posts', 'on');
  }
}

if (isset($_GET['activate']) && $_GET['activate'] == 'true') {
    phpinclusion_install();
}

if (get_option('phpinclusion_posts')=='on')  {
	add_filter('the_content', 'phpinclusion_check', 100);
	add_filter('the_excerpt','phpinclusion_check', 100);
}

//Hooks
add_action("plugins_loaded", "ECadmanager_create_ad_widget"); //Create the Widget
if (is_admin()) { add_action('admin_menu', 'ECadmanager_add_admin_menu'); } //Admin pages



/*
Copyright 2008 Mr Parkle
(Original wp125 plugin Copyright 2008 Matt Harzewski)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

?>